%  3 LAYER MODEL  %


clear
clf

xdim=300; %max x
ydim=3000;  %max y
dx=1;             %dx=dy
Lx=xdim*dx; %area to surf
Ly=ydim*dx;

v1=2; %wave velocities
v2=3;


dt=.1;

phi1=(v1^2)*(dt^2)/(dx^2); %phi for each velocity
phi2=(v2^2)*(dt^2)/(dx^2);


for i=1:xdim+1
    for j=1:ydim+1
        Alast(i,j)=0;
        A(i,j)=0;
    end
end
A(xdim-3:xdim+1,ydim/4-2:ydim/4+2)=80; %left side initial condition


xx=0:dx:Lx;
yy=0:dx:Ly;
[X,Y]=meshgrid(yy,xx);
surf(X,Y,A);
axis([Ly/4 3*Ly/4 0 Lx]);

f=0
Anew=A;
for iter=1:2500

    for i=2:xdim
        for j=2:ydim

               
               if i<(xdim/2)+100
                    Anew(i,j) = 2*A(i,j) - Alast(i,j) + phi2*(A(i+1,j)+A(i-1,j)+A(i,j+1)+A(i,j-1)-4*A(i,j));
                end
                if i>=(xdim/2)+100
                    Anew(i,j) = 2*A(i,j) - Alast(i,j) + phi1*(A(i+1,j)+A(i-1,j)+A(i,j+1)+A(i,j-1)-4*A(i,j));
                end
                
        end
    end

Alast=A;
A=Anew;
 
    

subplot (2,1,1);   

if mod(iter,5)==1
    surf(X,Y,A);
    axis([Ly/4 3*Ly/4 0 Lx]);
    caxis([0,60]);    
    shading interp
    view(0,90)
    zlim([-200,200]);
end


Z=A(xdim-10,:);

subplot(2,1,2);


if mod(iter,100)==1
    Z=Z+(iter/10);
plot(Z);
axis ([ydim/4 3*ydim/4 0 max(Z)])


end

hold on

    
    
pause(0.000001)

if mod(iter+49,50)==0
     f=f+1;

    saveas(gcf, ['2layerleft_',sprintf('%03d',f),'.png'])
end

end

clear
clf




%REPEAT FOR THE RIGHT SIDE
xdim=300; %max x
ydim=3000;  %max y
dx=1;             %dx=dy
Lx=xdim*dx; %area to surf
Ly=ydim*dx;

v1=2; %wave velocities
v2=3;


dt=.1;

phi1=(v1^2)*(dt^2)/(dx^2); %phi for each velocity
phi2=(v2^2)*(dt^2)/(dx^2);


for i=1:xdim+1
    for j=1:ydim+1
        Alast(i,j)=0;
        A(i,j)=0;
    end
end
f=0
A(xdim-3:xdim+1,3*ydim/4-2:3*ydim/4+2)=80; %right side

xx=0:dx:Lx;
yy=0:dx:Ly;
[X,Y]=meshgrid(yy,xx);
surf(X,Y,A);
axis([Ly/4 3*Ly/4 0 Lx]);


Anew=A;
for iter=1:2500

    for i=2:xdim
        for j=2:ydim

               if i<(xdim/2)+100
                    Anew(i,j) = 2*A(i,j) - Alast(i,j) + phi2*(A(i+1,j)+A(i-1,j)+A(i,j+1)+A(i,j-1)-4*A(i,j));
                end
                if i>=(xdim/2)+100
                    Anew(i,j) = 2*A(i,j) - Alast(i,j) + phi1*(A(i+1,j)+A(i-1,j)+A(i,j+1)+A(i,j-1)-4*A(i,j));
                end
                
        end
    end

Alast=A;
A=Anew;
 
    
subplot (2,1,1);   

if mod(iter,5)==1
    surf(X,Y,A);
  axis([Ly/4 3*Ly/4 0 Lx]);
    caxis([0,60]);    
    shading interp
    view(0,90)
    zlim([-200,200]);
end


Z=A(xdim-10,:);

subplot(2,1,2);


if mod(iter,100)==1
    Z=Z+(iter/10);
plot(Z);
axis ([ydim/4 3*ydim/4 0 max(Z)])



end

hold on

    
    
pause(0.000001)

if mod(iter+49,50)==0
     f=f+1;

    saveas(gcf, ['2layerright_',sprintf('%03d',f),'.png'])
end

end

